/* Copyright (C) 2011, 2012, 2013 by Bundesanstalt für Gewässerkunde
 * Software engineering by Intevation GmbH
 *
 * This file is Free Software under the GNU AGPL (>=v3)
 * and comes with ABSOLUTELY NO WARRANTY! Check out the
 * documentation coming with Dive4Elements River for details.
 */

package org.dive4elements.river.client.client.ui.uinfo;

import org.dive4elements.river.client.client.FLYSConstants;
import org.dive4elements.river.client.client.ui.AbstractSingleItemPanel;
import org.dive4elements.river.client.shared.model.DataList;

import com.smartgwt.client.widgets.Canvas;
import com.smartgwt.client.widgets.Label;
import com.smartgwt.client.widgets.form.DynamicForm;
import com.smartgwt.client.widgets.form.fields.TextItem;
import com.smartgwt.client.widgets.layout.VLayout;

public class InundationWMSInputPanel extends AbstractSingleItemPanel {

    private static final long serialVersionUID = 1L;
    private final boolean isEditable;

    public InundationWMSInputPanel(final FLYSConstants msg, final String titleForCreateOld, final boolean isEditable) {
        super(new UinfoInundationSingleYearEpochBehaviour(msg, titleForCreateOld));
        this.isEditable = isEditable;
    }

    @Override
    protected String getDatakey() {
        return "year_epoch_select";
    }

    @Override
    protected String errorForItemMsg() {
        return this.MSG.no_data_for_input();
    }

    @Override
    public Canvas createWidget(final DataList data) {
        final VLayout layout = new VLayout();

        final Label title = new Label(data.get(0).getDescription());
        title.setHeight("25px");

        final DynamicForm form = new DynamicForm();
        form.setNumCols(4);

        final TextItem inputItem = createInputItem("INPUT");
        inputItem.setWidth(250);
        inputItem.setCanEdit(this.isEditable);
        inputItem.setShowTitle(false);
        form.setFields(inputItem);

        layout.addMember(title);
        layout.addMember(form);

        return layout;
    }

}